#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void unos_n_u_bin(char* izlaz);
void prikazi_sadrzaj_datoteke(char* ulaz);
void azuriraj_dat(char* izlaz);
void prikazi_dat_for(char* ulaz);
void prikazi_dat_for_obrnuto(char* ulaz);
void sortiraj_dat(char* ulaz);

int main() {
	unos_n_u_bin("Izlaz.dat");
	
	//prikazi_sadrzaj_datoteke("Izlaz.dat");
	//azuriraj_dat("Izlaz.dat");

	//printf("\n");
	//prikazi_sadrzaj_datoteke("Izlaz.dat");

	//prikazi_dat_for("Izlaz.dat");

	//prikazi_dat_for_obrnuto("Izlaz.dat");

	sortiraj_dat("Izlaz.dat");
	prikazi_sadrzaj_datoteke("Izlaz.dat");

	system("pause");
	return 0;
}

void unos_n_u_bin(char* izlaz) {
	FILE* dat = fopen(izlaz, "wb");
	int n;

	printf("Koliko brojeva? ");
	scanf("%d", &n);

	for (int i = 0; i < n; i++) {
		int br;
		printf("Unesi %d. broj", i + 1);
		scanf("%d", &br);
		fwrite(&br, sizeof(int), 1, dat);
	}
	fclose(dat);
 }

void prikazi_sadrzaj_datoteke(char* ulaz) {
	FILE* dat = fopen(ulaz, "rb");
	int x;
	if (dat == NULL) {
		printf("\nGreska: fajl ne postoji ");
		return;
	}
	while (fread(&x, sizeof(int), 1, dat)!=0) {
		printf("%d ", x);
	}
	fclose(dat);
}

void azuriraj_dat(char* izlaz){
	FILE* dat = fopen(izlaz, "r+b");// moze i rb+
	if (dat != NULL) {
		printf("\nAzuriraj dat");
		int x;
		int broj=0;
		int a = -1;
		while (fread(&x, sizeof(int), 1, dat) != 0)	{
			if (x % 2 == 0) {
				fseek(dat, a * sizeof(int), SEEK_CUR);
				fwrite(&broj, sizeof(int), 1, dat);
				fflush(dat);
			}
		}
		fclose(dat);
	}
	else
	{
		printf("\nGreska kod citanja dat");
	}
}

//Prikazi sadrzaj dat
void prikazi_dat_for(char* ulaz) {
	FILE* dat = fopen(ulaz, "rb");
	if (dat != NULL) {
		fseek(dat, 0, SEEK_END); //seek_end znaci pozicioniraj se od kraja
		int x = ftell(dat)/sizeof(int);
		printf("brel=%d\n", x);
		fseek(dat, 0, SEEK_SET); //ovo je efikasnije; ako ima ovo, ne treba nam u foru
		for (int i = 0; i < x; i++) {
			//fseek(dat, i * sizeof(int), SEEK_SET); //seek_set znaci pozicioniraj se od pocetka
			int br;
			fread(&br, sizeof(int), 1, dat);
			printf("%d ", br);
		}
		fclose(dat);
	}
	else{
		printf("\ngreska");
	}
	//for(int i=0;fread(dat,sizeof(int;i++)

}

//Prikazi sadrzaj dat u obrnutom redosledu
void prikazi_dat_for_obrnuto(char* ulaz) {
	FILE* dat = fopen(ulaz, "rb");
	if (dat != NULL) {
		fseek(dat, 0, SEEK_END); //seek_end znaci pozicioniraj se od kraja
		int x = ftell(dat) / sizeof(int);
		printf("brel=%d\n", x);
		//fseek(dat, 0, SEEK_SET);
		for (int i = 1; i <= x; i++) {
			int a = -i;
			fseek(dat, a * sizeof(int), SEEK_END); //seek_set znaci pozicioniraj se od pocetka
			int br;
			fread(&br, sizeof(int), 1, dat);
			printf("%d ", br);
		}
		fclose(dat);
	}
	else {
		printf("\ngreska");
	}
	//for(int i=0;fread(dat,sizeof(int;i++)

}

void sortiraj_dat(char* ulaz) {
	FILE* dat = fopen(ulaz, "rb+");

	fseek(dat, 0, SEEK_END); 
	int x = ftell(dat) / sizeof(int);//gledam koliko ima elemenata
	int bi, bj;//bi ce biti broj na poziciji i, a bj broj na poziciji j
	for (int i = 0; i < x-1; i++) {
		//sledeca dva reda ne treba da stoje
		
		//fseek(dat, i*sizeof(int), SEEK_SET); //pozicioniram se na i-tu poziciju
		//fread(&bi, sizeof(int), 1, dat);//citam el na toj poz
		for (int j = i+1; j < x; j++) {
			fseek(dat, j * sizeof(int), SEEK_SET);//pozicioniram se na j-tu poziciju
			fread(&bj, sizeof(int), 1, dat);//citam el na toj poz
			fseek(dat, i * sizeof(int), SEEK_SET); //pozicioniram se na i-tu poziciju
			fread(&bi, sizeof(int), 1, dat);//citam el na toj poz
			if (bj < bi) {//Ovo je u rastucem, za opadajuci se pise bj>bi
				fseek(dat, i * sizeof(int), SEEK_SET);
				fwrite(&bj, sizeof(int), 1, dat);
				fseek(dat, j * sizeof(int), SEEK_SET);
				fwrite(&bi, sizeof(int), 1, dat);
			}
		}
	}
}